/* FILE PROPTST4.C */

/* test for rcsc - retargetable concurrent smallc compiler */
/* use with PROTOKEN.M4 to create Spin file                */

/* include standard defines and required variables */
/* remember: RCSC only has one level of include, nested includes are not supported */
/* remember: use dos 8.3 filenames only */
#include ".\rcsc_lib\_stdio.h"
#include "prop.h"

  /* first the global definitions */
  char ca[32];  /*  32 */
  int i,j;      /*   4 */
  int ia[10];   /*  20 */


  /* then the functions, including main */

test2(u) int *u; {
  *u = 128;
}

test3 () {
  return 4;
}

/* as there is no commandline, main has no arguments */
main () {
  char k; int p, q, r[6];

  printf("Hello world\015",0);
  k='Z';       /* for stack integrity check */
  p = 65;
  printf("p = %d (should be 65)\015",p);
  test2(&p);   /* pass address of p, test2 makes p = 128 */
  printf("p = %d (should be 128)\015",p);

  q = test3(); /* test3 returns 4 */
  printf("q = %d (should be 4)\015",q);

  i=p;
  printf("i=p i = %d\015",i);

  j=q;
  printf("j=q j = %d\015",j);

  /* try all operators */
  ia[0] = i + j;  /*  132 */
  printf("ia[0] = %d (should be 132)\015",ia[0]);
  ia[1] = i - j;  /*  124 */
  printf("ia[1] = %d (should be 124)\015",ia[1]);
  ia[2] = i * j;  /*  512 */
  printf("ia[2] = %d (should be 512)\015",ia[2]);
  ia[3] = i / j;  /*   32 */
  printf("ia[3] = %d (should be 32)\015",ia[3]);
  ia[4] = i % j;  /*    0 */
  printf("ia[4] = %d (should be 0)\015",ia[4]);
  ia[5] = i ^ j;  /*  132 */
  printf("ia[5] = %d (should be 132)\015",ia[5]);
  ia[6] = i & j;  /*    0 */
  printf("ia[6] = %d (should be 0)\015",ia[6]);
  ia[7] = i | j;  /*  132 */
  printf("ia[7] = %d (should be 132)\015",ia[7]);
  ia[8] = i << j; /* 2048 */
  printf("ia[8] = %d (should be 2048)\015",ia[8]);
  ia[9] = i >> j; /*    8 */
  printf("ia[9] = %d (should be 8)\015",ia[9]);

  j = 1;    /* 1 */
  printf("j=1 j = %d (should be 1)\015",j);
  j += 1;   /* 2 */
  printf("j+=1 j = %d (should be 2)\015",j);
  j -= 1;   /* 1 */
  printf("j-=1 j = %d (should be 1)\015",j);
  j *= 2;   /* 2 */
  printf("j*=2 j = %d (should be 2)\015",j);
  j /= 2;   /* 1 */
  printf("j/=2 j = %d (should be 1)\015",j);
  j %= 8;   /* 1 */
  printf("j%%=8 j = %d (should be 1)\015",j);
  j ^= 7;   /* 6 */
  printf("j^=7 j = %d (should be 6)\015",j);
  j &= 3;   /* 2 */
  printf("j&=3 j = %d (should be 2)\015",j);
  j |= 1;   /* 3 */
  printf("j|=1 j = %d (should be 3)\015",j);



  for (i=0; i<32; i++) {
    ca[i] = 0;
    printf("ca[%d] = ",i);
    printf("%d\015",ca[i]);
  }


  i=10;
  printf("i=10 i = %d (should be 10)\015",i);
  if (i <  11) {ca[0]=1;}   /* 1 */
  printf("ca[0] = %d (should be 1)\015",ca[0]);
  if (i >  11) {ca[1]=1;}   /* 0 */
  printf("ca[1] = %d (should be 0)\015",ca[1]);
  if (i <= 11) {ca[2]=1;}   /* 1 */
  printf("ca[2] = %d (should be 1)\015",ca[2]);
  if (i >= 11) {ca[3]=1;}   /* 0 */
  printf("ca[3] = %d (should be 0)\015",ca[3]);
  if (i == 11) {ca[4]=1;}   /* 0 */
  printf("ca[4] = %d (should be 0)\015",ca[4]);
  if (i != 11) {ca[5]=1;}   /* 1 */
  printf("ca[5] = %d (should be 1)\015",ca[5]);

  i=11;
  printf("i=11 i = %d (should be 11)\015",i);
  if (i <  11) {ca[8]=1;}   /* 0 */
  printf("ca[8] = %d (should be 0)\015",ca[8]);
  if (i >  11) {ca[9]=1;}   /* 0 */
  printf("ca[9] = %d (should be 0)\015",ca[9]);
  if (i <= 11) {ca[10]=1;}  /* 1 */
  printf("ca[10] = %d (should be 1)\015",ca[10]);
  if (i >= 11) {ca[11]=1;}  /* 1 */
  printf("ca[11] = %d (should be 1)\015",ca[11]);
  if (i == 11) {ca[12]=1;}  /* 1 */
  printf("ca[12] = %d (should be 1)\015",ca[12]);
  if (i != 11) {ca[13]=1;}  /* 0 */
  printf("ca[13] = %d (should be 0)\015",ca[13]);

  i=12;
  printf("i=12 i = %d (should be 12)\015",i);
  if (i <  11) {ca[16]=1;}  /* 0 */
  printf("ca[16] = %d (should be 0)\015",ca[16]);
  if (i >  11) {ca[17]=1;}  /* 1 */
  printf("ca[17] = %d (should be 1)\015",ca[17]);
  if (i <= 11) {ca[18]=1;}  /* 0 */
  printf("ca[18] = %d (should be 0)\015",ca[18]);
  if (i >= 11) {ca[19]=1;}  /* 1 */
  printf("ca[19] = %d (should be 1)\015",ca[19]);
  if (i == 11) {ca[20]=1;}  /* 0 */
  printf("ca[20] = %d (should be 0)\015",ca[20]);
  if (i != 11) {ca[21]=1;}  /* 1 */
  printf("ca[21] = %d (should be 1)\015",ca[21]);

  i=-2;
  printf("i=-2 i = %d (should be -2)\015",i);
  if (i <  0) {ca[24]=1;}   /* 1 */
  printf("ca[24] = %d (should be 1)\015",ca[24]);
  if (i >  0) {ca[25]=1;}   /* 0 */
  printf("ca[25] = %d (should be 0)\015",ca[25]);
  if (i <= 0) {ca[26]=1;}   /* 1 */
  printf("ca[26] = %d (should be 1)\015",ca[26]);
  if (i >= 0) {ca[27]=1;}   /* 0 */
  printf("ca[27] = %d (should be 0)\015",ca[27]);
  if (i == 0) {ca[28]=1;}   /* 0 */
  printf("ca[28] = %d (should be 0)\015",ca[28]);
  if (i != 0) {ca[29]=1;}   /* 1 */
  printf("ca[29] = %d (should be 1)\015",ca[29]);

  switch (i) {
    case 255: i='a';
              break;
    case 257: i='b';
              break;
    case 1024: i='c';
              break;
    default: i = 0;
  }
  printf("after switch i = %d (should be 0)\015",i);

  for (i=0; i<23; i+=2) ;
  printf("after for i = %d (should be 24)\015",i);
  do {
   i -= 3;
  } while (i > 0);
  printf("after do i = %d (should be 0)\015",i);

  while (1) ; /* keep alive */

}

/* system calls */

nop() { /* native function */
#asm
NOP
#endasm
}

ccargc() { /* native function */
#asm
CCARGC
#endasm
}

/*
  Set bit in 32bits register RADIR
  This will make the corresponding RA pin an output.

  @param bit Bitindex 0-31
*/
setbitRADIR(bit) int bit; {
#asm
SETRADIR
#endasm
}

/*
  Clear bit in 32bits register RADIR
  This will make the corresponding RA pin an input.

  @param bit Bitindex 0-31
*/
clearbitRADIR(bit) int bit; {
#asm
CLRRADIR
#endasm
}

/*
  Invert bit in 32bits register RADIR
  This will change the direction of the corresponding RA pin.

  @param bit Bitindex 0-31
*/
invertbitRADIR(bit) int bit; {
#asm
INVRADIR
#endasm
}

/*
  Write byte to 32bits register RADIR
  This will set the direction of 8 adjacent RA pins (0-7,8-15,16-23,24-31).
  A 0 bit will make an input, a 1 bit will make an output.

  @param index Byteindex 0-3
  @param byte Value 0-255
*/
writebyteRADIR(index,byte) int index,byte; {
#asm
WBRADIR
#endasm
}

/*
  Write word to 32bits register RADIR
  This will set the direction of 16 adjacent RA pins (0-15,16-31).
  A 0 bit will make an input, a 1 bit will make an output.

  @param index Wordindex 0-1
  @param word Value 0-65535
*/
writewordRADIR(index,word) int index,word; {
#asm
WWRADIR
#endasm
}

/*
  Read byte from 32bits register RADIR

  @param index Byteindex 0-3
  @return Byte read (0-255)
*/
readbyteRADIR(index,byte) int index,byte; {
#asm
RBRADIR
#endasm
}

/*
  Read word from 32bits register RADIR

  @param index Wordindex 0-1
  @return Word read (0-65535)
*/
readwordRADIR(index,word) int index,word; {
#asm
RWRADIR
#endasm
}

/*
  Set bit in 32bits register RA
  This will make the output level of the corresponding RA pin high.

  @param bit Bitindex 0-31
*/
setbitRA(bit) int bit; {
#asm
SETRA
#endasm
}

/*
  Clear bit in 32bits register RA
  This will make the output level of the corresponding RA pin low.

  @param bit Bitindex 0-31
*/
clearbitRA(bit) int bit; {
#asm
CLRRA
#endasm
}

/*
  Invert bit in 32bits register RA
  This will toggle the output level of the corresponding RA pin.

  @param bit Bitindex 0-31
*/
invertbitRA(bit) int bit; {
#asm
INVRA
#endasm
}

/*
  Write byte to 32bits register RA
  This will set the output levels of 8 adjacent RA pins (0-7,8-15,16-23,24-31).
  A 0 bit will set it low, a 1 bit will set it high.

  @param index Byteindex 0-3
  @param byte Value 0-255
*/
writebyteRA(index,byte) int index,byte; {
#asm
WBRA
#endasm
}

/*
  Write word to 32bits register RA
  This will set the output levels of 16 adjacent RA pins (0-15,16-31).
  A 0 bit will set it low, a 1 bit will set it high.

  @param index Wordindex 0-1
  @param word Value 0-65535
*/
writewordRA(index,word) int index,word; {
#asm
WWRA
#endasm
}

/*
  Read byte from 32bits register RA

  @param index Byteindex 0-3
  @return Byte read (0-255)
*/
readbyteRA(index,byte) int index,byte; {
#asm
RBRA
#endasm
}

/*
  Read word from 32bits register RA

  @param index Wordindex 0-1
  @return Word read (0-65535)
*/
readwordRA(index,word) int index,word; {
#asm
RWRA
#endasm
}

printf(buf,val) char *buf; int val; { /* native function */
#asm
PRINTF
#endasm
}

/* end */
